/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <page.h>
#include <page/routines.h>
#include <page/types.h>
#include <page/mem.h>

int page_read(struct page **const head, const unsigned long addr,
    void *const buf, const size_t n)
{
    if (!*head)
        return (*head = page_mem_alloc(addr)) ? 0 : -1;

    struct page *const p = page_from_addr(*head, addr);

    if (!p)
        /* TODO: decide best strategy (fs, mem, etc.) */
        return page_add(*head, addr, page_mem_alloc);

    return p->ops->read(p, buf, n, addr);
}
